Index: /palm/trunk/SOURCE/netcdf_data_input_mod.f90
===================================================================
--- /palm/trunk/SOURCE/netcdf_data_input_mod.f90	(revision 3967)
+++ /palm/trunk/SOURCE/netcdf_data_input_mod.f90	(revision 3968)
@@ -5358,36 +5611,15 @@
        ENDIF
 
-
-       !Temporary solution for reading emission chemistry files: TBD: we should discuss whether remove it or not
-       IF ( id==id_emis ) THEN
-
-          !--    Allocate temporary variable according to memory access on file. 
-          ALLOCATE( tmp(is:ie,js:je) )
-
-          !--    Get variable
-          nc_stat = NF90_GET_VAR( id, id_var, tmp,                                &
-                                  start = (/ is,      js /),                  &
-                                  count = (/ ie-is+1 , je-js+1 /) ) 
-
-          var=tmp
-
-          CALL handle_error( 'get_variable_2d_real', 530, variable_name ) !TBD: the error number shuld be changed, but since the solution is 
-                                                                          ! provisory, we give the same as below
- 
-          DEALLOCATE( tmp )
-       
-       !>  Original Subroutine part
-       ELSE
-!
-!--       Allocate temporary variable according to memory access on file. 
-          ALLOCATE( tmp(is:ie,js:je) )
-!
-!--       Get variable
-          nc_stat = NF90_GET_VAR( id, id_var, tmp,                             &
-                                  start = (/ is+1,      js+1 /),               &
-                                  count = (/ ie-is + 1, je-js+1 /) )   
+!
+!-- Allocate temporary variable according to memory access on file. 
+       ALLOCATE( tmp(is:ie,js:je) )
+!
+!-- Get variable
+       nc_stat = NF90_GET_VAR( id, id_var, tmp,            &
+                      start = (/ is+1,      js+1 /),       &
+                      count = (/ ie-is + 1, je-js+1 /) )   
           CALL handle_error( 'get_variable_2d_real', 530, variable_name )
 !
-!--       Resort data. Please note, dimension subscripts of var all start at 1. 
+!-- Resort data. Please note, dimension subscripts of var all start at 1. 
           DO  i = is, ie 
              DO  j = js, je 
@@ -5398,5 +5630,4 @@
           DEALLOCATE( tmp )
 
-       ENDIF
 #endif
     END SUBROUTINE get_variable_2d_real
@@ -5713,49 +5944,30 @@
        ENDIF
 
-      !Temporary solution for reading emission chemistry files: 
-       IF ( id==id_emis ) THEN
-
-          !--    Allocate temporary variable according to memory access on file. 
-          ALLOCATE( tmp(is:ie,js:je,k1s:k1e,k2s:k2e) )
-
-          !--    Get variable
-          nc_stat = NF90_GET_VAR( id, id_var, tmp,                                &
-                                  start = (/ is,   js,   k1s+1,   k2s+1 /),                  &
-                                  count = (/ ie-is+1 , je-js+1, k1e-k1s+1, k2e-k2s+1 /) ) 
-
-          var=tmp
+!
+!-- Allocate temporary variable according to memory access on file. 
+       ALLOCATE( tmp(is:ie,js:je,k1s:k1e,k2s:k2e) )
+!
+!-- Get variable
+       nc_stat = NF90_GET_VAR( id, id_var, tmp,                                &
+                      start = (/ is+1,    js+1,    k1s+1,     k2s+1 /),        &
+                      count = (/ ie-is+1, je-js+1, k1e-k1s+1, k2e-k2s+1 /) )
 
           CALL handle_error( 'get_variable_4d_real', 535, variable_name )
- 
-          DEALLOCATE( tmp )
-
-       !> Original subroutine part
-       ELSE
-!
-!--       Allocate temporary variable according to memory access on file. 
-          ALLOCATE( tmp(is:ie,js:je,k1s:k1e,k2s:k2e) )
-!
-!--       Get variable
-          nc_stat = NF90_GET_VAR( id, id_var, tmp,                             &
-                               start = (/ is+1,    js+1,   k1s+1, k2s+1 /),    &
-                               count = (/ ie-is+1, je-js+1,                    &
-                                          k1e-k1s+1, k2e-k2s+1 /) )
-
-          CALL handle_error( 'get_variable_4d_real', 535, variable_name )
-!
-!--       Resort data. Please note, dimension subscripts of var all start at 1. 
-          DO  i = is, ie 
-             DO  j = js, je
-                DO  k1 = k1s, k1e
-                   DO  k2 = k2s, k2e
-                      var(k2-k2s+1,k1-k1s+1,j-js+1,i-is+1) = tmp(i,j,k1,k2)
-                   ENDDO
+!
+!-- Resort data. Please note, dimension subscripts of var all start at 1. 
+       DO  i = is, ie 
+          DO  j = js, je
+             DO  k1 = k1s, k1e
+                DO  k2 = k2s, k2e
+                   var(k2-k2s+1,k1-k1s+1,j-js+1,i-is+1) = tmp(i,j,k1,k2)
                 ENDDO
              ENDDO
           ENDDO
-
-          DEALLOCATE( tmp )
-       ENDIF
+       ENDDO
+
+       DEALLOCATE( tmp )
+
 #endif
+
     END SUBROUTINE get_variable_4d_real
 
@@ -5806,5 +6018,5 @@
 
       !Temporary solution for reading emission chemistry files: 
-       IF ( id==id_emis ) THEN
+       IF ( id == id_emis ) THEN
 
           !--    Allocate temporary variable according to memory access on file. 
@@ -5993,5 +6205,5 @@
 
       !Temporary solution for reading emission chemistry files: 
-       IF ( id==id_emis ) THEN
+       IF ( id == id_emis ) THEN
 
           !--    Allocate temporary variable according to memory access on file. 
@@ -6040,4 +6252,232 @@
     END SUBROUTINE get_variable_5d_to_4d_real
 
+    
+!------------------------------------------------------------------------------!
+! Description:
+! ------------
+!> Reads a 5D float variable from file. 
+!> NOTE - This subroutine is used specific for reading NC variable
+!>        emission_values having a "z" dimension.  Said dimension
+!>        is to be removed in the future and this subroutine shall
+!>        be depreciated accordingly (ecc 20190418)
+!------------------------------------------------------------------------------!
+    SUBROUTINE get_variable_5d_real( id, variable_name, var, is, ie, js, je,   &
+                                     k1s, k1e, k2s, k2e, k3s, k3e )
+
+       USE indices
+       USE pegrid
+
+       IMPLICIT NONE
+
+       CHARACTER(LEN=*)          ::  variable_name  !< variable name
+
+       INTEGER(iwp)              :: i       !< i index
+       INTEGER(iwp)              :: ie      !< i index start
+       INTEGER(iwp)              :: is      !< i index end
+       INTEGER(iwp)              :: id_var  !< netCDF variable ID (varid)
+       INTEGER(iwp)              :: j       !< j index
+       INTEGER(iwp)              :: je      !< j index start
+       INTEGER(iwp)              :: js      !< j index end
+       INTEGER(iwp)              :: k1      !< k1 index
+       INTEGER(iwp)              :: k1e     !< k1 index start
+       INTEGER(iwp)              :: k1s     !< k1 index end
+       INTEGER(iwp)              :: k2      !< k2 index
+       INTEGER(iwp)              :: k2e     !< k2 index start
+       INTEGER(iwp)              :: k2s     !< k2 index end
+       INTEGER(iwp)              :: k3      !< k3 index
+       INTEGER(iwp)              :: k3e     !< k3 index start
+       INTEGER(iwp)              :: k3s     !< k3 index end
+       INTEGER(iwp), INTENT(IN)  :: id      !< netCDF file ID (ncid)
+
+       REAL(wp), DIMENSION(:,:,:,:,:), ALLOCATABLE    :: tmp  !< temp array to read data from file
+       REAL(wp), DIMENSION(:,:,:,:,:), INTENT(INOUT)  :: var  !< variable to be read 
+
+#if defined( __netcdf )
+
+!
+!-- Inquire variable id
+
+       nc_stat = NF90_INQ_VARID( id, TRIM( variable_name ), id_var )
+
+!
+!-- Check for collective read-operation and set respective NetCDF flags if required.
+ 
+       IF ( collective_read )  THEN
+
+#if defined( __netcdf4_parallel )       
+          nc_stat = NF90_VAR_PAR_ACCESS (id, id_var, NF90_COLLECTIVE)
+#endif
+
+       ENDIF
+
+!
+!-- Allocate temporary variable according to memory access on file. 
+
+       ALLOCATE( tmp(is:ie,js:je,k1s:k1e,k2s:k2e,k3s:k3e) )
+
+!
+!-- Get variable from file
+
+       nc_stat = NF90_GET_VAR ( id, id_var, tmp,                                         &
+                      start = (/ is+1,    js+1,    k1s+1,     k2s+1,     k3s+1 /),       &
+                      count = (/ ie-is+1, je-js+1, k1e-k1s+1, k2e-k2s+1, k3e-k3s+1 /) )
+
+       CALL handle_error( 'get_variable_5d_real', 535, variable_name )
+
+!
+!-- Resort (reverse index order) and standardize (from 1 to N) output array
+
+       DO  i = is, ie 
+          DO  j = js, je
+             DO  k1 = k1s, k1e
+                DO  k2 = k2s, k2e
+                   DO k3 = k3s, k3e
+                      var(k3-k3s+1,k2-k2s+1,k1-k1s+1,j-js+1,i-is+1) = tmp(i,j,k1,k2,k3)
+                   ENDDO
+                ENDDO
+             ENDDO
+          ENDDO
+       ENDDO
+
+       DEALLOCATE( tmp )
+
+#endif
+
+    END SUBROUTINE get_variable_5d_real
+
+
+!------------------------------------------------------------------------------!
+! Description:
+! ------------
+!> Reads a 5D float variables from dynamic driver, such as time-dependent xy-, 
+!> xz- or yz-boundary data as well as 5D initialization data. Please note, 
+!> the passed arguments are start indices and number of elements in each 
+!> dimension, which is in contrast to the other 3d versions where start- and 
+!> end indices are passed. The different handling of 5D dynamic variables is 
+!> due to its asymmetry for the u- and v component.
+!> NOTE(1) - This subroutine is more flexible than get_variable_xd_real as it
+!>           provides much better control over starting and count indices
+!>           (ecc 20190418)
+!> NOTE(2) - This subroutine is used specific for reading NC variable
+!>           emission_values having a "z" dimension.  Said dimension
+!>           is to be removed in the future and this subroutine shall
+!>           be depreciated accordingly (ecc 20190418)
+!------------------------------------------------------------------------------!
+
+    SUBROUTINE get_variable_5d_real_dynamic( id, variable_name, var,                       &
+                                             i1s, i2s, i3s, i4s, i5s,                      &
+                                             count_1, count_2, count_3, count_4, count_5,  &
+                                             par_access )
+
+       USE indices
+       USE pegrid
+
+       IMPLICIT NONE
+
+       CHARACTER(LEN=*)          ::  variable_name  !< variable name
+
+       LOGICAL                   ::  par_access     !< additional flag indicating parallel read
+
+       INTEGER(iwp)              ::  count_1  !< # elements read in dimension 1 wrt file
+       INTEGER(iwp)              ::  count_2  !< # elements read in dimension 2 wrt file
+       INTEGER(iwp)              ::  count_3  !< # elements read in dimension 3 wrt file
+       INTEGER(iwp)              ::  count_4  !< # elements read in dimension 4 wrt file
+       INTEGER(iwp)              ::  count_5  !< # elements read in dimension 5 wrt file
+       INTEGER(iwp)              ::  i1       !< index for dimension 1 on file
+       INTEGER(iwp)              ::  i1s      !< starting index for dimension 1 hyperslab
+       INTEGER(iwp)              ::  i2       !< index for dimension 2 on file
+       INTEGER(iwp)              ::  i2s      !< starting index for dimension 2 hyperslab
+       INTEGER(iwp)              ::  i3       !< index for dimension 3 on file
+       INTEGER(iwp)              ::  i3s      !< starting index for dimension 3 hyperslab
+       INTEGER(iwp)              ::  i4       !< index for dimension 4 on file
+       INTEGER(iwp)              ::  i4s      !< starting index for dimension 4 hyperslab
+       INTEGER(iwp)              ::  i5       !< index for dimension 5 on file
+       INTEGER(iwp)              ::  i5s      !< starting index for dimension 5 hyperslab
+       INTEGER(iwp)              ::  id_var   !< netCDF variable id (varid)
+       INTEGER(iwp)              ::  lb1      !< lower bound of dimension 1 wrt file
+       INTEGER(iwp)              ::  lb2      !< lower bound of dimension 2 wrt file
+       INTEGER(iwp)              ::  lb3      !< lower bound of dimension 3 wrt file
+       INTEGER(iwp)              ::  lb4      !< lower bound of dimension 4 wrt file
+       INTEGER(iwp)              ::  lb5      !< lower bound of dimension 5 wrt file
+       INTEGER(iwp)              ::  ub1      !< upper bound of dimension 1 wrt file
+       INTEGER(iwp)              ::  ub2      !< upper bound of dimension 2 wrt file
+       INTEGER(iwp)              ::  ub3      !< upper bound of dimension 3 wrt file
+       INTEGER(iwp)              ::  ub4      !< upper bound of dimension 4 wrt file
+       INTEGER(iwp)              ::  ub5      !< upper bound of dimension 5 wrt file
+       INTEGER(iwp), INTENT(IN)  ::  id       !< netCDF file id (ncid)
+
+       REAL(wp), DIMENSION(:,:,:,:,:), ALLOCATABLE    ::  tmp  !< temporary variable to read data
+                                                               !< from file according is reverse
+                                                               !< array index order
+       REAL(wp), DIMENSION(:,:,:,:,:), INTENT(INOUT)  ::  var  !< input variable
+       
+#if defined( __netcdf )
+
+!
+!-- Inquire variable id.
+
+       nc_stat = NF90_INQ_VARID( id, TRIM( variable_name ), id_var )
+
+!
+!-- Check for collective read-operation and set respective NetCDF flags if required. 
+!-- Please note, in contrast to the other input routines where each PEs 
+!-- reads its subdomain data, dynamic input data not by all PEs, only
+!-- by those which encompass lateral model boundaries. Hence, collective
+!-- read operations are only enabled for top-boundary data.
+
+       IF ( collective_read  .AND.  par_access )  THEN
+
+#if defined( __netcdf4_parallel )       
+          nc_stat = NF90_VAR_PAR_ACCESS (id, id_var, NF90_COLLECTIVE)
+#endif
+
+       ENDIF
+
+!
+!-- Allocate temporary variable according to memory access on file. 
+!-- Therefore, determine dimension bounds of input array. 
+
+       lb1 = LBOUND(var,5)
+       ub1 = UBOUND(var,5)
+       lb2 = LBOUND(var,4)
+       ub2 = UBOUND(var,4)
+       lb3 = LBOUND(var,3)
+       ub3 = UBOUND(var,3)
+       lb4 = LBOUND(var,2)
+       ub4 = UBOUND(var,2)
+       lb5 = LBOUND(var,1)
+       ub5 = UBOUND(var,1)
+       ALLOCATE ( tmp(lb1:ub1,lb2:ub2,lb3:ub3,lb4:ub4,lb5:ub5) )
+
+!
+!-- Get variable
+
+       nc_stat = NF90_GET_VAR(  id, id_var, tmp,                                         &
+                      start = (/ i1s,     i2s,     i3s,     i4s,     i5s     /),         &
+                      count = (/ count_1, count_2, count_3, count_4, count_5 /) )
+
+       CALL handle_error( 'get_variable_3d_real_dynamic', 537, variable_name )
+
+!
+!-- Assign temp array to output.  Note reverse index order 
+
+       DO  i5 = lb5, ub5
+          DO  i4 = lb4, ub4
+             DO  i3 = lb3, ub3
+                DO i2 = lb2, ub2
+                   DO  i1 = lb1, ub1
+                      var(i5,i4,i3,i2,i1) = tmp(i1,i2,i3,i4,i5)
+                   ENDDO
+                ENDDO
+             ENDDO
+          ENDDO
+       ENDDO
+
+       DEALLOCATE( tmp )
+
+#endif
+
+    END SUBROUTINE get_variable_5d_real_dynamic
+
 
 !------------------------------------------------------------------------------!
Index: /palm/trunk/SOURCE/time_integration.f90
===================================================================
--- /palm/trunk/SOURCE/time_integration.f90	(revision 3967)
+++ /palm/trunk/SOURCE/time_integration.f90	(revision 3968)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! replace nspec_out with n_matched_vars
+! 
+! 3929 2019-04-24 12:52:08Z banzhafs
 ! Reverse changes back from revision 3878: use chem_boundary_conds instead of
 ! chem_boundary_conds_decycle
@@ -518,5 +521,5 @@
 
     USE chem_modules,                                                                              &
-        ONLY:  bc_cs_t_val, chem_species, cs_name, emissions_anthropogenic, nspec_out
+        ONLY:  bc_cs_t_val, chem_species, cs_name, emissions_anthropogenic, n_matched_vars
 
     USE chemistry_model_mod,                                                                       &
@@ -1448,5 +1451,5 @@
 !--       Call emission routine only once an hour
           IF (hour_of_year  .GT.  hour_call_emis )  THEN
-             CALL chem_emissions_setup( chem_emis_att, chem_emis, nspec_out )
+             CALL chem_emissions_setup( chem_emis_att, chem_emis, n_matched_vars )
              hour_call_emis = hour_of_year
           ENDIF
